## qtcreator 15.0.1

=== tests/CMakeLists.txt ===
add_subdirectory(auto)
add_subdirectory(manual)
add_subdirectory(tools/qml-ast2dot)
if (WITH_QMLDESIGNER)
  add_subdirectory(unit)
endif()
