=== debian/changelog ===
qtcreator (15.0.1-1build3) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.3 (LP: #2103945).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 29 Mar 2025 15:11:59 -0500

qtcreator (15.0.1-1build2) plucky; urgency=medium

  * No-change rebuild for LLVM 20.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Feb 2025 22:01:18 +0100

qtcreator (15.0.1-1build1) plucky; urgency=medium

  * No-change rebuild for Qt 6.8.2.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 04 Feb 2025 18:32:15 -0600

qtcreator (15.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 26 Jan 2025 10:35:01 +0100
